<?php
session_start();
require_once('../../conexion.php');
require_once('../../include/sesiones.php');
// Declaramos la librería
require  ('vendor/autoload.php');

$desde=$_GET['desde'];
$hasta=$_GET['hasta'];


$utt=0;
$pcc=0;
$pvv=0;

$uttc=0;
$pccc=0;
$pvvc=0;

$registros=mysqli_query($con,"SELECT * FROM ventas where ven_fecha BETWEEN '$desde' AND '$hasta' and sucursal='$sucursal' and empresa='$empresa' and ven_estado<>'anulada' order by ven_n_venta desc") or die(mysqli_error($con));

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

$spread = new Spreadsheet();

$sheet = $spread->getActiveSheet();
$sheet->getStyle('A:Z')->getAlignment()->setHorizontal('center');/* centar contenido de celdas */
$sheet->mergeCells('A1:E1')->mergeCells('A2:E2');/*combinas celdas*/

function cellColor($cells,$color)/* FUNSION PARA COLORES DE CELDA*/
{
    global $sheet;

    $sheet->getStyle($cells)->getFill()
    ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
    ->getStartColor()
    ->setARGB($color);
}

cellColor('A2:E2', 'BDBDBD'); 
cellColor('A1:E1', 'BDBDBD'); 
cellColor('A3:E3', 'FF4D00'); 


$sheet->setCellValue('A1', 'REPORTE PERDIDA Y GANANCIA')
            ->setCellValue('A2', 'DESDE '.$desde.' HASTA '.$hasta)
            ->setCellValue('A3', 'VENTAS')
            ->setCellValue('B3', 'COMPRAS')
            ->setCellValue('C3', 'UTILIDAD')
            ->setCellValue('D3', 'EGRESOS')
            ->setCellValue('E3', 'GANANCIA');


          
                    //Ancho de las columnas
$sheet->getColumnDimension('A')->setWidth(20);   
$sheet->getColumnDimension('B')->setWidth(20);  
$sheet->getColumnDimension('C')->setWidth(20); 
$sheet->getColumnDimension('D')->setWidth(20); 
$sheet->getColumnDimension('E')->setWidth(20);

    $cel=4;//Numero de fila donde empezara a crear  el reporte

$hasta1 = strtotime($hasta."+ 1 days");
date("Y-m-d",$hasta1) . "\n";
$hastaf=date("Y-m-d",$hasta1) . "\n";

while ($reg=mysqli_fetch_array($registros))
{
    $ven_id=$reg['ven_id'];
    $sql=mysqli_query($con, "SELECT * from venta_detalle where ventas_ven_id='$ven_id' AND  vend_art_id<>'5770' AND vend_art_id<>'5771'  and vend_art_id<>'8577'");
    while ($row=mysqli_fetch_array($sql))
    {
        $vend_art_id=$row['vend_art_id'];
        $vend_cantidad=$row['vend_cantidad_dev'];
        $vend_costo=$row['vend_costo'];
        $vend_precio_real=$row['vend_precio_real'];

        if ($vend_costo==null) {
                $art=mysqli_query($con, "SELECT * from articulos where art_id='$vend_art_id'");
                $row1=mysqli_fetch_array($art);
                if($row1==null)
                {
                    $art2=mysqli_query($con, "SELECT avg(comd_precio) as comd_precio, sum(comd_cantidad) comd_cantidad FROM `compra_detalle` WHERE comd_art_id='$vend_art_id'");
                    $row2=mysqli_fetch_array($art2);
                    $precio_costo=$row2['comd_precio'];

                }
                else
                {
                    $precio_costo=$row1['art_precio_costo'];
                }
            }
            else
            {
                $precio_costo=$vend_costo;
            }

        $costo=$precio_costo*$vend_cantidad;
        $venta=$vend_precio_real*$vend_cantidad;
        $utilidad=$venta-$costo;

        $pcc+=$costo;   
        $pvv+=$venta;
        $utt+=$utilidad;
    } 


    $sqlc=mysqli_query($con, "SELECT * from venta_detalle_combo where ven_id='$ven_id' ");
    while ($rowc=mysqli_fetch_array($sqlc))
    {
        $combo_id=$rowc['combo_id'];
        $combo_cantidad=$rowc['combo_cantidad'];
        $combo_nombre=$rowc['combo_nombre'];
        $combo_costo=$rowc['combo_costo'];
        $combo_precio=$rowc['combo_precio'];
        $combo_desc=$rowc['combo_desc'];

        if ($combo_costo==null) 
        {
            $totalprecio_costo=0;
            $com=mysqli_query($con, "SELECT * from combos_articulos where combos_com_id='$combo_id'");
            while ($com1=mysqli_fetch_array($com))
            {
                $coma_art_id=$com1['coma_art_id'];
                $coma_art_cantidad=$com1['coma_art_cantidad'];
                $artc=mysqli_query($con, "SELECT * from articulos where art_id='$coma_art_id'");
                $row1=mysqli_fetch_array($artc);
                $totalprecio_costo+=$precio_costo=$row1['art_precio_costo']*$coma_art_cantidad;
            }    
        }
        else
        {
            $totalprecio_costo=$combo_costo;
        }   

        $costo_combo=$totalprecio_costo*$combo_cantidad;
        $venta_combo=$combo_precio*$combo_cantidad;
        $utilidad_combo=$venta_combo-$costo_combo;

        $pccc+=$costo_combo;   
        $pvvc+=$venta_combo;
        $uttc+=$utilidad_combo;
    }

}

$vds=mysqli_query($con,"SELECT sum(total) as egre FROM egresos where fecha BETWEEN '$desde' AND '$hasta' and sucursal='$sucursal' and empresa='$empresa'") or die(mysqli_error($con));  
$vd=mysqli_fetch_array($vds);
$egre=$vd['egre']; 


        $a="a".$cel;
        $b="b".$cel;
        $c="c".$cel;
        $d="d".$cel;
        $e="e".$cel;

        // Agregar datos
        $sheet
        ->setCellValue($a, number_format($pvv+$pvvc,0))
        ->setCellValue($b, number_format($pcc+$pccc,0))
        ->setCellValue($c, number_format($utt+$uttc,0))
        ->setCellValue($d, number_format($egre,0))
        ->setCellValue($e, number_format(($utt+$uttc)-$egre,0));




// Redirigir la salida al navegador web de un cliente ( Excel5 )
header('Content-Type: application/vnd.ms-excel');
header('Content-Disposition: attachment;filename="REPORTE PERDIDA Y GANANCIA.xlsx"');
header('Cache-Control: max-age=0');
// Si usted está sirviendo a IE 9 , a continuación, puede ser necesaria la siguiente
header('Cache-Control: max-age=1');

$writer = new Xlsx($spread);
$writer->save('php://output');
exit;
/*
$fileName="Descarga_excel.xlsx";
# Crear un "escritor"
$writer = new Xlsx($spread);
# Le pasamos la ruta de guardado

header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment; filename="'. urlencode($fileName).'"');
$writer->save('php://output');
?>*/
?>